package gov.va.vss.model.requirement;

import static com.fasterxml.jackson.annotation.JsonAutoDetect.Visibility.NONE;
import static com.fasterxml.jackson.annotation.JsonAutoDetect.Visibility.PUBLIC_ONLY;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.DiscriminatorValue;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.OneToMany;

import org.hibernate.annotations.BatchSize;

import com.fasterxml.jackson.annotation.JsonAutoDetect;
import com.fasterxml.jackson.annotation.JsonIgnore;

@Entity
@DiscriminatorValue("FR")
@JsonAutoDetect(fieldVisibility = NONE, getterVisibility = PUBLIC_ONLY, isGetterVisibility = PUBLIC_ONLY)
public class FacilityRoleRequirement extends FacilityRequirement {
	private static final long serialVersionUID = 5406082811830107442L;

	// ---------------------------------------- Fields

	private List<BenefitingServiceRoleRequirementAssociation> benefitingServiceRoleRequirementAssociations;

	// ---------------------------------------- Constructors

	// ---------------------------------------- Business Methods

	// ---------------------------------------- Accessor Methods

	@OneToMany(mappedBy = "requirement", fetch = FetchType.LAZY)
	@BatchSize(size = 500)
	@JsonIgnore
	private List<BenefitingServiceRoleRequirementAssociation> getBenefitingServiceRoleAssociations() {
		if (benefitingServiceRoleRequirementAssociations == null)
			benefitingServiceRoleRequirementAssociations = new ArrayList<>();
		return benefitingServiceRoleRequirementAssociations;
	}

	public void setBenefitingServiceRoleAssociations(
			List<BenefitingServiceRoleRequirementAssociation> benefitingServiceRoleRequirementAssociations) {
		this.benefitingServiceRoleRequirementAssociations = benefitingServiceRoleRequirementAssociations;
	}

}
