package gov.va.vss.model.requirement;

import static com.fasterxml.jackson.annotation.JsonAutoDetect.Visibility.NONE;
import static com.fasterxml.jackson.annotation.JsonAutoDetect.Visibility.PUBLIC_ONLY;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.DiscriminatorValue;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.OneToMany;

import org.hibernate.annotations.BatchSize;

import com.fasterxml.jackson.annotation.JsonAutoDetect;
import com.fasterxml.jackson.annotation.JsonIgnore;

@Entity
@DiscriminatorValue("GR")
@JsonAutoDetect(fieldVisibility = NONE, getterVisibility = PUBLIC_ONLY, isGetterVisibility = PUBLIC_ONLY)
public class GlobalRoleRequirement extends GlobalRequirement {
	private static final long serialVersionUID = 5406082811830107442L;

	// ---------------------------------------- Fields

	private List<BenefitingServiceRoleTemplateAssociation> benefitingServiceRoleTemplateAssociations;

	// ---------------------------------------- Constructors

	// ---------------------------------------- Business Methods

	// ---------------------------------------- Accessor Methods

	@OneToMany(mappedBy = "requirement", fetch = FetchType.LAZY)
	@BatchSize(size = 500)
	@JsonIgnore
	private List<BenefitingServiceRoleTemplateAssociation> getBenefitingServiceRoleTemplateAssociations() {
		if (benefitingServiceRoleTemplateAssociations == null)
			benefitingServiceRoleTemplateAssociations = new ArrayList<>();
		return benefitingServiceRoleTemplateAssociations;
	}

	public void setBenefitingServiceRoleTemplateAssociations(
			List<BenefitingServiceRoleTemplateAssociation> benefitingServiceRoleTemplateAssociations) {
		this.benefitingServiceRoleTemplateAssociations = benefitingServiceRoleTemplateAssociations;
	}

}
