package gov.va.vss.persistence.dao.leie;

import java.io.IOException;
import java.util.Collection;
import java.util.List;

import org.apache.http.client.ClientProtocolException;

import gov.va.vss.model.Volunteer;
import gov.va.vss.model.leie.ExcludedEntity;
import gov.va.vss.persistence.dao.CustomizableSortedDAO;

public interface ExcludedEntityDAO extends CustomizableSortedDAO<ExcludedEntity> {

	public static interface ImportDataCallback {
		void processRecord(ExcludedEntity e);
	}

	public static class ExcludedEntityMatch {
		private Volunteer volunteer;
		private ExcludedEntity excludedEntity;

		public ExcludedEntityMatch(Volunteer volunteer, ExcludedEntity excludedEntity) {
			this.volunteer = volunteer;
			this.excludedEntity = excludedEntity;
		}

		public Volunteer getVolunteer() {
			return volunteer;
		}

		public ExcludedEntity getExcludedEntity() {
			return excludedEntity;
		}

	}

	int importData(ImportDataCallback callback) throws ClientProtocolException, IOException;

	List<ExcludedEntity> findByCriteria(String searchValue, int start, int length, String orderBy);

	int[] getTotalAndFilteredNumber(String searchValue);

	List<ExcludedEntityMatch> findExcludedEntities(Collection<Long> vaFacilityIds);

}
