package gov.va.vss.persistence.dao.requirement;

import java.util.List;

import gov.va.vss.model.requirement.VolunteerRequirement;
import gov.va.vss.persistence.dao.CustomizableAppDAO;
import gov.va.vss.persistence.queryCustomization.QueryCustomization;

public interface VolunteerRequirementDAO extends CustomizableAppDAO<VolunteerRequirement> {

	int bulkAddNecessaryRequirements(long benefitingServiceRoleId);
	
	int bulkRemoveUnnecessaryRequirements(long benefitingServiceRoleId);
	
	
	/**
	 * List all requirements for volunteer including national as well as as local facility for localFacilityId 
	 * @param localFacilityId
	 * @return
	 */
	List<VolunteerRequirement> findByCriteria(long volunteerId, long facilityId, QueryCustomization... customization);

	/**
	 * Performs bulk insert of all VolunteerRequirements for a specific volunteer
	 * @param volunteerId
	 */
	int bulkInsertForVolunteerIfNecessary(long volunteer, long facilityIdForNewRequirements);

	/**
	 * Performs bulk insert of VolunteerRequirement for a newly created requirement to all qualified volunteers
	 * @param requirement
	 * @return
	 */
	int bulkInsertForNewRequirement(long  requirementId);
	
	int bulkUpdateDateToNull(long requirementId);
}

