package gov.va.vss.persistence.impl;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.persistence.Query;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Repository;

import gov.va.vss.model.DonGenPostFund;
import gov.va.vss.persistence.dao.DonGenPostFundDAO;
import gov.va.vss.persistence.queryCustomization.QueryCustomization;

@Repository
public class DonGenPostFundDAOImpl extends GenericHibernateSortedDAOImpl<DonGenPostFund> implements DonGenPostFundDAO {
	@SuppressWarnings("unused")
	private static final Logger log = LoggerFactory.getLogger(DonGenPostFundDAOImpl.class);
	
	/*
	 * @Override public List<DonGenPostFund> findByCriteria(Long id,
	 * QueryCustomization... customization) { return null; }
	 */

	@SuppressWarnings("unchecked")
	@Override
	public List<DonGenPostFund> findDonGenPostFundByFacilityId(long facilityId) {
		StringBuilder sb = new StringBuilder("select d from ").append(DonGenPostFund.class.getName()).append(" d");
		sb.append(" left join fetch d.facility f");

		QueryCustomization cust = new QueryCustomization();

		if (cust.getOrderBy() == null)
			cust.setOrderBy("d.generalPostFund");

		List<String> whereClauseItems = new ArrayList<>();
		Map<String, Object> params = new HashMap<>();

		if (facilityId > 0) {
			whereClauseItems.add("d.facility.id = :facilityId");
			params.put("facilityId",facilityId);
		}

		Query q = constructQuery(em, sb, whereClauseItems, params, null, cust);

		return q.getResultList();
	}


}
