package gov.va.vss.persistence.impl.requirement;

import javax.persistence.Query;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Repository;

import gov.va.vss.model.requirement.BenefitingServiceRoleRequirementAssociation;
import gov.va.vss.persistence.dao.requirement.BenefitingServiceRoleRequirementAssociationDAO;
import gov.va.vss.persistence.impl.GenericHibernateDAOImpl;

@Repository
public class BenefitingServiceRoleRequirementAssociationDAOImpl
		extends GenericHibernateDAOImpl<BenefitingServiceRoleRequirementAssociation>
		implements BenefitingServiceRoleRequirementAssociationDAO {
	@SuppressWarnings("unused")
	private static final Logger log = LoggerFactory.getLogger(BenefitingServiceRoleRequirementAssociationDAOImpl.class);

	@Override
	public int bulkDeleteByCriteria(Long benefitingServiceRoleId) {
		if (benefitingServiceRoleId == null)
			throw new IllegalArgumentException("Must specify at least one piece of filtering criteria");

		flush();

		Query q = query("delete from " + BenefitingServiceRoleRequirementAssociation.class.getName()
				+ " where id in (select vfa.id from " + BenefitingServiceRoleRequirementAssociation.class.getName()
				+ " vfa" //
				+ " where (1=2" //
				+ (benefitingServiceRoleId != null ? " or vfa.benefitingServiceRole.id = :benefitingServiceRoleId" : "") //
				+ "))");
		if (benefitingServiceRoleId != null)
			q.setParameter("benefitingServiceRoleId", benefitingServiceRoleId);
		return q.executeUpdate();
	}

}
