package gov.va.vss.service;

import gov.va.shared.service.validation.ServiceValidationException;
import gov.va.vss.model.requirement.AbstractRequirement;

public interface RequirementService {

	/**
	 * @param requirement
	 *            The Requirement to save or update
	 * @return The updated requirement after it's been merged
	 * @throws ServiceValidationException 
	 */
	AbstractRequirement saveOrUpdate(AbstractRequirement requirement, boolean isDateTypeChangedToNotApplicable) throws ServiceValidationException;

	/**
	 * Deletes the Parking Sticker with the specified parkingStickerId
	 * 
	 * @param requirementId
	 *            The ID of the requirement to delete
	 */
	void delete(long requirementId);

}
