package gov.va.vss.service.impl.requirement;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.stereotype.Service;

import gov.va.shared.model.Permission;
import gov.va.vss.model.requirement.VolunteerRequirement;
import gov.va.vss.service.impl.AbstractServiceImpl;
import gov.va.vss.service.requirement.VolunteerRequirementService;

@Service
public class VolunteerRequirementServiceImpl extends AbstractServiceImpl implements VolunteerRequirementService {
	private static final Logger log = LoggerFactory.getLogger(VolunteerRequirementServiceImpl.class);

	@Override
	public VolunteerRequirement saveOrUpdate(VolunteerRequirement volunteer) {
		return volunteerRequirementDAO.saveOrUpdate(volunteer);
	}

	@Override
	public void delete(long volunteerRequirementId) {
		volunteerRequirementDAO.delete(volunteerRequirementId);
	}

	@Override
	public void syncRequirementsForBulkChange(Long benefitingServiceRoleId) {
		volunteerRequirementDAO.bulkAddNecessaryRequirements(benefitingServiceRoleId);
		volunteerRequirementDAO.bulkRemoveUnnecessaryRequirements(benefitingServiceRoleId);
	}

	@Override
	@PreAuthorize("hasAuthority('" + Permission.VOLUNTEER_CREATE + "')")
	public int bulkInsertForVolunteerIfNecessary(long volunteerId, long facilityId) {
		return volunteerRequirementDAO.bulkInsertForVolunteerIfNecessary(volunteerId, facilityId);
	}

}
