package gov.va.vss.service.requirement;

import gov.va.vss.model.requirement.VolunteerRequirement;

public interface VolunteerRequirementService {

	VolunteerRequirement saveOrUpdate(VolunteerRequirement volunteer);

	void delete(long volunteerRequirementId);

	/**
	 * This method adds necessary but missing requirements to all volunteers who
	 * have a VolunteerAssignment linked to the specified BenefitingServiceRole.
	 * Then this method removes all superfluous VolunteerRequirements from all
	 * the same volunteers, in the event that global requirements were removed.
	 * 
	 * @param benefitingServiceRoleId
	 */
	void syncRequirementsForBulkChange(Long benefitingServiceRoleId);

	int bulkInsertForVolunteerIfNecessary(long volunteerId, long facilityId);
}
