package gov.va.vss.service.scheduledJobs;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.transaction.PlatformTransactionManager;

import gov.va.shared.model.AppUser;
import gov.va.shared.persistence.AppUserDAO;
import gov.va.shared.persistence.LdapPersonDAO;
import gov.va.shared.persistence.lookup.sds.VAFacilityDAO;
import gov.va.shared.service.AppUserService;
import gov.va.shared.util.SecurityUtil;
import gov.va.vss.persistence.dao.ApplicationParametersDAO;
import gov.va.vss.persistence.dao.PrintRequestDAO;
import gov.va.vss.persistence.dao.facility.KioskDAO;
import gov.va.vss.persistence.dao.views.FacilityAndVisnDAO;
import gov.va.vss.service.ExcludedEntityService;
import gov.va.vss.service.KioskService;
import gov.va.vss.service.PrintRequestService;
import gov.va.vss.service.VolunteerService;

public abstract class AbstractScheduledJob {

	@Autowired
	protected ApplicationParametersDAO applicationParametersDAO;
	@Autowired
	protected AppUserDAO appUserDAO;
	@Autowired
	protected AppUserService appUserService;
	@Autowired
	protected VAFacilityDAO vAFacilityDAO;
	@Autowired
	protected FacilityAndVisnDAO institutionAndVisnDAO;
	@Autowired
	protected ExcludedEntityService excludedEntityService;
	@Autowired
	protected LdapPersonDAO ldapPersonDAO;
	@Autowired
	protected KioskDAO kioskDAO;
	@Autowired
	protected KioskService kioskService;
	@Autowired
	protected PrintRequestDAO printRequestDAO;
	@Autowired
	protected PrintRequestService printRequestService;
	@Autowired
	protected VolunteerService volunteerService;

	@Autowired
	@Qualifier("transactionManager")
	protected PlatformTransactionManager tm;

	protected AppUser queryUser() {
		return appUserDAO.findByUsername(SecurityUtil.getCurrentUserName(), false);
	}

}
