<%@ include file="../shared/inc_header.jsp"%>

<script type="text/javascript">

$(function() {
	initEditRequirementPopup() 
})

function initEditRequirementPopup() {
	
	var dialogEl = $("#editRequirementDialog")
	dialogEl.dialog({
		autoOpen : false,
		modal : false,
		width : 600,
		height : 300,
		closeOnEscape : true,
		draggable : true,
		resizable : true,
		buttons : {
			'Submit' : {
				text : 'Submit',
				id : 'editRequirementSubmit',
				click : function() {
					submitRequirementButtonClicked()
				}
			},
			'Cancel' : function() {
				$(this).dialog('close')
			}
		}
	})
	
	$("#editRequirementDialog").show()
}

function isDateTypeChangedToNotApplicable() {
	var requirementId = $("#editRequirementDialog").data('requirementId')
	var isNew = (typeof requirementId == 'undefined' || requirementId == '')
	var requirementObj = isNew ? null : requirementMap[mode][requirementId]
	var dateType = $("#editRequirementDateType").val()

	return (!isNew && (dateType == '${DateValueNotApplicable.id}' &&  requirementObj.dateType.id != '${DateValueNotApplicable.id}'))
}

var submitRequirementButtonClicked = function() {	
	
	if (isDateTypeChangedToNotApplicable())	{ 
		confirmDialog('<span style="color:red">Warning: Changing the date type to Not Applicable will delete any dates ' +
				'already entered in the system for this requirement.  Do you wish to continue?</span>', submitEditRequirement)		
	}	else {
		submitEditRequirement()
	}
}

var submitEditRequirement = function() {
	var facilityType = $("#editRequirementFacilityType").val()
	var name = $("#editRequirementName").val()
	var description = $("#editRequirementDescription").val()
	var dateType = $("#editRequirementDateType").val()
	
	if (!validateEditRequirement())
		return false
	
	$.ajax({
		url : ajaxHomePath + '/requirement/saveOrUpdate',
		method: 'POST',
		dataType : 'json',
		data : {
			requirementId : $("#editRequirementDialog").data('requirementId'),
			facilityType : facilityType,
			name : name,
			description : description,
			dateType : dateType,
			isActive : $("#editRequirementActive").is(":checked"),
			isDateTypeChangedToNotApplicable : isDateTypeChangedToNotApplicable()
		},
		error : commonAjaxErrorHandler,
		success : function(response) {
			$("#editRequirementDialog").dialog('close')
			refreshRequirementsTable(facilityType)
	    }
	})
}

function showRequirementPopup(requirementId) {
	var isNew = typeof requirementId == 'undefined'
	var mode = $("#requirementFacilityLocal").is(":checked") ? 'local' : 'global'

	var facilityName = (mode=='local' ? '<c:out value="${facilityContextName}" />' : 'National')
	
	$("#editRequirementDialog").dialog('option', 'title', isNew ? 'New Requirement' : 'Edit Requirement')
	$("#editRequirementDialog").data('requirementId', requirementId || '')

	var requirementObj = isNew ? null : requirementMap[mode][requirementId]
	$("#editRequirementFacilitySpan").text(facilityName)
	$("#editRequirementFacilityType").val(mode)
	$("#editRequirementName").val(isNew ? '' : requirementObj.name)
	$("#editRequirementDescription").val(isNew ? '' : requirementObj.description)
	$("#editRequirementActive").prop('checked', isNew ? true : !requirementObj.inactive)
	$("#editRequirementDateType").val((isNew || !requirementObj.dateType) ? '${DateValueNotApplicable.id}' : requirementObj.dateType.id)
	
	$("#editRequirementDialog").dialog('open')
}

function validateEditRequirement() {
	var allErrors = new Array()
	
	var nameVal = $.trim($("#editRequirementName").val())
	if (nameVal == '') {
		allErrors.push('Please enter the Name.')
	}

	var descVal = $.trim($("#editRequirementDescription").val())
	if (descVal == '') {
		allErrors.push('Please enter the Description.')
	}

	if (allErrors.length > 0)
		displayAttentionDialog("Please correct the following errors: <ul><li>"
				+ allErrors.join("</li><li>") + "</li></ul>");

	return allErrors.length == 0
}

</script>

<div id="editRequirementDialog" style="display: none"
	title="Edit Requirement">
	
	<input id="editRequirementFacilityType" type="hidden" value="local"/>
	
	<div class="clearCenter">
		<table>
			<tr><td align="right"><label for="editRequirementFacilitySpan">Facility:</label></td>
				<td></td>
				<td><span id="editRequirementFacilitySpan" title="Facility"></span></td>
			</tr>		
			<tr>
				<td align="right"><label for="editRequirementName">Name:
				<span class="invisibleRequiredFor508">*</span></label></td>
				<td style="padding: 4px; text-align: center" width="1"><span
									class='requdIndicator'>*</span></td>
				<td><input type="text" id="editRequirementName" title="Type name" size="35"
							maxLength="50"/></td>
			</tr>
			<tr>
				<td><label for="editRequirementDescription">Description:
				<span class="invisibleRequiredFor508">*</span></label></td>
				<td style="padding: 4px; text-align: center" width="1"><span
									class='requdIndicator'>*</span></td>
				<td>
				<textarea id="editRequirementDescription" title="Type Description" rows="3" cols="50"  maxlength="250"></textarea></td>
			</tr>
			<tr>
					<td class='appFieldLabel' nowrap><label for="editRequirementDateType">Date Type:</label></td>
					<td></td>
					<td><select id="editRequirementDateType" title="Slect Date Type">
							<c:forEach items="${allRequirementDateTypes}" var="dateType">
								<option value="${dateType.id}"><c:out
										value="${dateType.name}" /></option>
							</c:forEach>
					</select></td>
			</tr>
			<tr>
				<td></td>
				<td></td>
				<td><input type="checkbox"
					id="editRequirementActive" value="true"> Is Active</td>		
			</tr>
		</table>
	</div>
</div>