<%@ include file="../shared/inc_header.jsp"%>

<c:if test="${FORM_READ_ONLY}">
	<%@ include file="../shared/inc_modifyToView.jsp"%>
</c:if>

<%@ include file="editRequirementPopup.jsp"%>

<script type="text/javascript">
	var isReadOnly = ${FORM_READ_ONLY}
	var mode = null;
	
	<sec:authorize
	access="hasAuthority('${PERMISSION_REQUIREMENTS_LOCAL_MANAGE}')">
		mode = 'local'
	</sec:authorize>
	<sec:authorize
	access="hasAuthority('${PERMISSION_REQUIREMENTS_GLOBAL_MANAGE}')">
		mode = 'global'
	</sec:authorize>

	
	$(function() {
		buildRequirementsTable('#requirementLocalList');
		buildRequirementsTable('#requirementGlobalList');		
		
		$("#requirementFacilitySelectWrapper").toggle(mode != 'local')
		$("input[name=requirementFacility][value=" + (mode == 'global' ? "G" : "F")+ "]").prop("checked", true)

		var modeListener = function() {
			mode = $("#requirementFacilityLocal").is(":checked") ? 'local' : 'global'
			$("#requirementFacilityLocalWrapper").toggle(mode == 'local')
			$("#requirementFacilityGlobalWrapper").toggle(mode != 'local')
		}
		
		$("#requirementFacilityLocal").click(modeListener)
		$("#requirementFacilityGlobal").click(modeListener)
		modeListener()
		
		refreshRequirementsTable('local')
		refreshRequirementsTable('global')
	})
	
	var requirementMap = new Array();
	
	function buildRequirementsTable(tableName) {
		var theDataTable = $(tableName).DataTable({
			buttons: ['excel', {
				extend : 'pdfHtml5',
				orientation : 'landscape'
			}, 'print'],
			"columns" : [ {
		        	"render" : function(row, type, val, meta) {
		        		return '<a href="javascript:showRequirementPopup(' + val.id + ')">'+ 
		    			escapeHTML(val.name) + '</a>'
					}
				}, {
					"render" : function(row, type, val, meta) {
						return val.dateType ? val.dateType.name : ''
					}
				},  
				{
					"render" : function(row, type, val, meta) {
						return escapeHTML(val.description)
					}
				}, {
					"render" : function(row, type, val, meta) {
						return val.inactive ? 'Inactive' : 'Active'
					}
				}/*, {
					"render" : function(row, type, val, meta) {
						return '' // list of roles
					}
				}
				<c:if test="${not FORM_READ_ONLY}">
				, {
					"render" : function(row, type, val, meta) {
						var actions = '<div style="margin:0 auto; text-align:left"><nobr>'

						actions += '<a href="javascript:showEditRequirementPopup('
							+ val.id + ')"><img alt="Edit Requirement" src="'+ imgHomePath
							+ '/edit-small.gif" border="0" hspace="5" align="center"/></a>'
							
						actions += '<a href="javascript:deleteOrInactivateRequirement('
								+ val.id + ', ' + val.volunteerCount + ')"><img alt="Delete or Inactivate Requirement" src="'+ imgHomePath
								+ '/permanently_delete_18x18.png" border="0" hspace="5" align="center"/></a>'
						
						actions += '</nobr></div>'
						return actions
					}
				}
				</c:if>*/
			],
	    	"dom": '<"top"fBi>rt<"bottom"pl><"clear">',
	    	"lengthMenu" : [ [ 10, 50, -1 ],
	    	 				[ 10, 50, "All" ] ],
			"order": [],
	    	"pageLength": 10,
	    	"pagingType": "full_numbers",
	    	"stripeClasses" : [],
		})
		
	}
	
	function refreshRequirementsTable(tableMode) {
		requirementMap[tableMode] = new Object()
		
		$.ajax({
			url : ajaxHomePath + '/requirements/' + tableMode,
			dataType : 'json',
			data : {
			},
			error : commonAjaxErrorHandler,
			success : function(response) {
				var requirements = response
				
				var rArray = new Array()
				var curDate = new Date()
				
				for (var i = 0; i < requirements.length; i++) {
					var requirement = requirements[i]
					requirementMap[tableMode][requirement.id] = requirement
					rArray[rArray.length] = requirement
				}

				var tableName = 'requirement' + capitalize(tableMode) + 'List'
				var table = $('#' + tableName).DataTable()
				table.clear()
				table.rows.add(rArray)
				rebuildTableFilters(tableName)
				table.draw()
				
				$('#' + tableName +"_filter3").val('Active')
				$('#' + tableName + "_filter3").change()
		    }
		})
	}
	
	function capitalize(s) {
		return s.charAt(0).toUpperCase() + s.slice(1)
	}
	
	/*function deleteOrInactivateRequirement(requirementId, volCount) {
		var fullObj = requirementMap[???mode???][requirementId]
		var msg = 'Are you sure you want to delete "' + fullObj.name + '"?'*/
		/* if (volCount > 0)
			msg += '<span style="color:red; font-weight:bold"><p>This will AUTOMATICALLY INACTIVATE ALL facility and '
		    	+ volCount + ' volunteer assignment(s) using this service!<p>This action cannot be undone!</span>' */
	    /*confirmDialog(msg,
                function() {
  					$.ajax({
					url : ajaxHomePath + '/requirement/deleteOrInactivate',
					dataType : 'json',
					data : {
						requirementId: requirementId
					},
					error : commonAjaxErrorHandler,
					success : refreshRequirementsTable
				})
        })
	}*/
	
</script>

<style>
table#requirementGlobalList tr.serviceRow, table#requirementLocalList tr.serviceRow
{
	background-color: #dddddd;
}

table#requirementGlobalList, table#requirementLocalList {
	border-collapse: collapse;
}

table#requirementGlobalList td, table#requirementLocalList td {
	margin: 3px;
}

.requirementFacilityGlobalWrapper, .requirementFacilityLocalWrapper {
	min-width: 400px;
}
</style>

<div id="requirementFacilitySelectWrapper" class="clearCenter">
		<table>
			<tr>
				<td align="right"><label for='requirementFacility'>Facility:</label></td>
				<td><input type="radio" id="requirementFacilityGlobal"
					name="requirementFacility" value="G" checked="checked">National <input type="radio"
					id="requirementFacilityLocal" name="requirementFacility" value="F">
					<c:out value="${facilityContextName}" /></td>
			</tr>
		</table>
	</div>

<p>
<div id="requirementFacilityGlobalWrapper" class="clearCenter" style="max-width:75%">
 	<fieldset>
		<legend>National Requirements</legend>
 	<div align="center" style="margin-bottom:15px">
 		<table>
			<tr>
				<td><a class="buttonAnchor"
					href="javascript:showRequirementPopup()" style="margin-right:60px">Add Requirement</a></td>
				</tr>
		</table>
	</div>
	<table class="formatTable" id="requirementGlobalList" border="1"
		summary="List of Requirements">
		<thead>
			<tr>
				<td class="noborder" width="25%"></td>
			<td class="noborder" width="15%" title="Filter by DateType"></td>
				<td class="noborder" width="50%"></td>
				<td class="noborder" width="10%" title="Filter by Status"></td>
				<%--<td class="noborder"></td>
				 <c:if test="${not FORM_READ_ONLY}">
					<td class="noborder"></td>
				</c:if>--%>
			</tr>
			<tr>
				<th>Name</th>
				<th class="select-filter">Date Type</th>
				<th>Description</th>
				<th class="select-filter">Status</th>
				<%--<th>Linked Roles</th>
					<c:if test="${not FORM_READ_ONLY}">
					<th>Action</th>
				</c:if>--%>
			</tr>
		</thead>
		<tbody>
		</tbody>
	</table>
			</fieldset>
	
</div>


<div id="requirementFacilityLocalWrapper" class="clearCenter" style="max-width:75%">
<fieldset>
		<legend>Facility Requirements</legend>

	<div align="center" style="margin-bottom:15px"> 
		<table>
			<tr>
				<td><a class="buttonAnchor"
					href="javascript:showRequirementPopup()" style="margin-right:60px">Add Requirement</a></td>
			<%-- 	<td>Facility:</td>
				<td><select id="facilityId">
						<c:if test="${not empty facilityContextId}">
							<option value="${facilityContextId}" selected="selected"><c:out
									value="${facilityContextName}" /></option>
						</c:if>
				</select></td>--%></tr>
		</table>
	</div>

	<table class="formatTable" id="requirementLocalList" border="1"
		summary="List of Requirements">
		<thead>
			<tr>
				<td class="noborder" width="25%"></td>
				<td class="noborder" width="15%" title="Filter by DateType"></td>
				<td class="noborder" width="50%"></td>
				<td class="noborder" width="10%" title="Filter by Status"></td>
				<%--<td class="noborder"></td>
				 <c:if test="${not FORM_READ_ONLY}">
					<td class="noborder"></td>
				</c:if>--%>
			</tr>
			<tr>
				<th>Name</th>
				<th>Date Type</th>
				<th>Description</th>
				<th class="select-filter">Status</th>
				<%--<th>Linked Roles</th>
					<c:if test="${not FORM_READ_ONLY}">
					<th>Action</th>
				</c:if>--%>
			</tr>
		</thead>
		<tbody>
		</tbody>
	</table>

</div>