<%@ include file="../shared/inc_header.jsp"%>

<script type="text/javascript">
$(function() {
	var submitVolunteerRequirement = function() {
		var myVolunteerRequirementId = $("#volunteerRequirementId").val()
		
		if (!validateVolunteerRequirement())
			return false

		$.ajax({
			url : ajaxHomePath + '/volunteer/volunteerRequirement/update',
			method: 'POST',
			dataType : 'json',
			data : {
				volunteerRequirementId: myVolunteerRequirementId,
				requirementDate: $("#volunteerRequirementDate").val(),
				status: $("#volunteerRequirementStatus").val(),
				comments: $("#volunteerRequirementComments").val()
			},
			error : commonAjaxErrorHandler,
			success : function(response) {
				$("#volunteerRequirementDialog").dialog('close')
				refreshRequirements()
		    }
		})
	}
	
	var dialogEl = $("#volunteerRequirementDialog")
	dialogEl.dialog({
		autoOpen : false,
		modal : false,
		width : 700,
		height : 350,
		closeOnEscape : true,
		draggable : true,
		resizable : true,
		buttons : {
			'Submit' : {
				text : 'Submit',
				id : 'volunteerRequirementSubmit',
				click : function() {
					submitVolunteerRequirement()
				}
			},
			'Cancel' : function() {
				$(this).dialog('close')
			}
		}
	})
	
	
	$("#parkingStickerDetailsDialog").show()
})

function validateVolunteerRequirement() {
	var allErrors = new Array()
	
	var dateVal = $('#volunteerRequirementDate').val()
	if (dateVal != '' && !validateDate(dateVal)) {
		allErrors.push('Please enter a valid date.')
	}

	if (allErrors.length > 0)
		displayAttentionDialog("Please correct the following errors: <ul><li>"
				+ allErrors.join("</li><li>") + "</li></ul>");

	return allErrors.length == 0
}

function showVolunteerRequirementPopup(volunteerRequirementId) {
	
	var volunteerRequirementObj = volunteerRequirementId ? volunteerRequirementData[volunteerRequirementId] : null
	var hasVolunteerRequirementObj = volunteerRequirementObj != null
	
	$("#volunteerRequirementId").val(hasVolunteerRequirementObj ? volunteerRequirementObj.id : '')

	$("#volunteerRequirementFacilitySpan").text(hasVolunteerRequirementObj && volunteerRequirementObj.requirement.facilityScope ? volunteerRequirementObj.requirement.facilityScope.displayName : 'National')
	$("#volunteerRequirementNameSpan").text(hasVolunteerRequirementObj ? volunteerRequirementObj.requirement.name : '')
	
	var dateTypeText = hasVolunteerRequirementObj && volunteerRequirementObj.requirement.dateType ? volunteerRequirementObj.requirement.dateType.name : ''
	$("#volunteerRequirementDateTypeSpan").text(dateTypeText)
	
	var isDateTypeNotApplicable = (dateTypeText == '${DateValueNotApplicable.name}')
	$("#volunteerRequirementDateRow").toggle(!isDateTypeNotApplicable)
	if (isDateTypeNotApplicable) {
		$("#volunteerRequirementDate").val('')
	} else {
		// Date should not be editable if date type is not applicable
		$("#volunteerRequirementDate").val(hasVolunteerRequirementObj ? volunteerRequirementObj.requirementDate : '')
	}
	
	$("#volunteerRequirementStatus").val(hasVolunteerRequirementObj && volunteerRequirementObj.status ? volunteerRequirementObj.status.id : '')
	$("#volunteerRequirementComments").val(hasVolunteerRequirementObj ? volunteerRequirementObj.comments : '')
	
	
	$("#volunteerRequirementDialog").dialog('open')
}
</script>

<div id="volunteerRequirementDialog" style="display: none"
	title="Volunteer Requirement Details">
	<input type="hidden" id="volunteerRequirementId" value="" />

	<div class="clearCenter volunteerRequirementInputFields ">
			<table>
				<tr>
				<td class='appFieldLabel'>Facility:</td>
					<td></td>
					<td><span id="volunteerRequirementFacilitySpan"></span></td>
				</tr>
					
				<tr>
				<td class='appFieldLabel'>Name:</td>
					<td></td>
					<td><span id="volunteerRequirementNameSpan"></span></td>
				</tr>
				<tr>
				<td class='appFieldLabel'>Date Type:</td>
					<td></td>
					<td><span id="volunteerRequirementDateTypeSpan"></span></td>
				</tr>
				<tr id="volunteerRequirementDateRow">
					<td align="right">Date:</td>
					<td width="10"></td>
					<td><input type="text" id="volunteerRequirementDate" class="dateInput"
						size="10" /></td>
				</tr>
				<tr>
					<td class='appFieldLabel' nowrap>Status:</td>
					<td></td>
					<td colspan="4"><select id="volunteerRequirementStatus">
							<option value=""></option>
							<c:forEach items="${allRequirementStatuses}" var="status">
								<option value="${status.id}"><c:out
										value="${status.name}" /></option>
							</c:forEach>
					</select></td>
				</tr>
				<tr>
					<td colspan="4">Comments:<br>
					<textarea rows="4" cols="55" id="volunteerRequirementComments" maxlength="2000"></textarea></td>
				</tr>
			</table>
	</div>
</div>