package gov.va.vss.persistence;

import org.junit.Test;
import org.springframework.beans.factory.annotation.Autowired;

import gov.va.vss.AbstractTransactionalWebDAOTest;
import gov.va.vss.model.VoluntaryServiceStaff;
import gov.va.vss.model.facility.Facility;
import gov.va.vss.persistence.dao.CustomizableAppDAO;
import gov.va.vss.persistence.dao.VoluntaryServiceStaffDAO;

public class TestVoluntaryServiceStaffDAO extends AbstractTransactionalWebDAOTest<VoluntaryServiceStaff> {

	@Autowired
	private VoluntaryServiceStaffDAO voluntaryServiceStaffDAO;

	@Override
	protected CustomizableAppDAO<VoluntaryServiceStaff> getDAO() {
		return voluntaryServiceStaffDAO;
	}

	@Override
	protected VoluntaryServiceStaff getInstanceToSave() {
		VoluntaryServiceStaff v = new VoluntaryServiceStaff();
		v.setAppUser(user);
		v.setReportOrder(1);
		Facility facility = findFacility("442");
		v.setFacility(facility);
		return v;
	}

	@Test
	public void testFindByCriteria() {
		VoluntaryServiceStaff staffsFor442 = voluntaryServiceStaffDAO.findByPrimaryKey(1800L);
		// Assert.assertFalse("Failed - 442 didn't return any results", staffsFor442 == null);
	}

	protected Facility findFacility(String stationNum) {
		return facilityDAO.findByStationNumber(stationNum);
	}

	@Override
	protected boolean testDelete() {
		return true;
	}

}
