package gov.va.vss.persistence.dao;

import java.math.BigDecimal;
import java.time.LocalDate;
import java.util.List;
import java.util.Map;

import gov.va.vss.model.donation.DonGenPostFund;

public interface DonGenPostFundDAO extends CustomizableSortedDAO<DonGenPostFund> {

	List<DonGenPostFund> findByFacility(long facilityId);

	DonGenPostFund findByProgramCode(String gpfCode, long facilityId);

	/**
	 * @param facilityId
	 * @param startDateInclusive
	 * @param endDateInclusive
	 * @return A map of GPF ID to [donation total, expenditure total, ledger adjustment total]
	 */
	Map<Long, BigDecimal[]> getDonGenPostFundReportByFacility(long facilityId, LocalDate startDateInclusive,
			LocalDate endDateInclusive);

}
