package gov.va.vss.service.impl;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Service;

import gov.va.shared.service.validation.ServiceValidationException;
import gov.va.vss.model.expenditure.Expenditure;
import gov.va.vss.service.ExpenditureService;

@Service
public class ExpenditureServiceImpl extends AbstractServiceImpl implements ExpenditureService {
	private static final Logger log = LoggerFactory.getLogger(ExpenditureServiceImpl.class);

	@Override
	public Expenditure saveOrUpdate(Expenditure expenditure) throws ServiceValidationException {
		/* Business-level validations */

		expenditure = expenditureDAO.saveOrUpdate(expenditure);
		return expenditure;
	}

	@Override
	public void delete(Long expenditureId) throws ServiceValidationException {
		expenditureDAO.delete(expenditureId);
	}

}
