<%@ include file="../shared/inc_header.jsp"%>

<c:if test="${FORM_READ_ONLY}">
	<%@ include file="../shared/inc_modifyToView.jsp"%>
</c:if>

<jsp:include page="../shared/inc_expenditureDetail.jsp">
	<jsp:param name="resultCallbackMethod"
		value="refreshGeneralLedgerTable" />
</jsp:include>

<script>
	var isReadOnly = ${FORM_READ_ONLY}
	var canCreateExpenditures = false
	var ledgerEntries = []
	
	<sec:authorize
	access="hasAnyAuthority('${PERMISSION_EDONATION_MANAGE}')">
		canCreateExpenditures = true
	</sec:authorize>

	$(function() {
		buildGeneralLedgerTable()
		refreshGeneralLedgerTable()
		
		$("#dateRangeType").change(refreshGeneralLedgerTable)
	})
	
	function buildGeneralLedgerTable() {
		var theDataTable = $('#generalLedgerList').DataTable({
			buttons: ['excel', {
				extend : 'pdfHtml5',
				orientation : 'landscape'
			}, 'print'],
			"columns" : [ {
		        	"render" : function(row, type, val, meta) {
		        		if (type === 'display')
							return '<a href="#" class="appLink"><nobr>' + (val.gpf ? val.gpf.generalPostFund : '') + '</nobr></a>'
						return (val.gpf ? val.gpf.generalPostFund : '')
		        	}
				}, {
					"render" : function(row, type, val, meta) {
						if (type === 'display')
							return "$" + val.balance
						return val.balance
					} 
				}, {
					"render" : function(row, type, val, meta) {
						if (type === 'display')
							return "$" + val.donationTotal + ' <a href="javascript:popupDonorSearch(\'menuAdd\')"><img align="right" style="margin-right:5px" src="'
								+ imgHomePath + '/add.png" border="0" /></a>'
						return val.donationTotal
					}
				}, {
					"render" : function(row, type, val, meta) {
						if (type === 'display')
							return "$" + val.expenditureTotal + ' <a href="javascript:newExpenditure(' + val.gpf.id
									+ ')"><img align="right" style="margin-right:5px" src="' + imgHomePath + '/add.png" border="0" /></a>'
						return val.expenditureTotal
					}
				}, {
					"render" : function(row, type, val, meta) {
						if (type === 'display')
							return "$" + val.ledgerAdjustmentTotal + ' <a href="javascript:newAdjustment(' + val.gpf.id
									+ ')"><img align="right" style="margin-right:5px" src="' + imgHomePath + '/add.png" border="0" /></a>'
						return val.ledgerAdjustmentTotal
					}
				}
				<%--
				<c:if test="${not FORM_READ_ONLY}">
				, {
					"render" : function(row, type, val, meta) {
						var actions = '<div style="margin:0 auto; text-align:left"><nobr>'
						actions += '<a class="appLink" href="javascript:popupDonorSearch(\'menuAdd\')">Add Donation</a>'
						if (val.gpf) {
							actions += '| <a class="appLink" href="javascript:newExpenditure(' + val.gpf.id + ')">Add Expenditure</a>'
						}
						actions += '</nobr></div>'
						return actions
					}
				} 
				</c:if>
				--%>
			],
	    	"dom": '<"top"fBi>rt<"bottom"pl><"clear">',
	    	"lengthMenu" : [ [ 20, 50, -1 ],
	    	 				[ 20, 50, "All" ] ],
			"order": [],
	    	"pageLength": 20,
	    	"pagingType": "full_numbers",
	    	"stripeClasses" : [],
	    	"drawCallback" : function() {
	    		var totals = [0, 0, 0, 0]
	    		
	    		for (var i = 0; i < ledgerEntries.length; i++) {
	    			totals[0] += ledgerEntries[i].balance
	    			totals[1] += ledgerEntries[i].donationTotal
	    			totals[2] += ledgerEntries[i].expenditureTotal
	    			totals[3] += ledgerEntries[i].ledgerAdjustmentTotal
	    		}
	    		for (var i = 0; i < 4; i++)
					$("#totalRow td:eq(" + (i+1) + ")")
							.text('$'+ formatAndAddThousandSeparators(totals[i]));
			}
		})
	}
	
	function refreshGeneralLedgerTable() {
		$.ajax({
			url : ajaxHomePath + '/ledgerSummary',
			dataType : 'json',
			data : {
				"dateRangeType" : $("#dateRangeType").val() 
			},
			error : commonAjaxErrorHandler,
			success : function(response) {
				ledgerEntries = response
				
				var table = $('#generalLedgerList').DataTable()
				table.clear()
				table.rows.add(response)
				table.draw()				
		    }
		})
	}
</script>

<style>
#generalLedgerList tr.serviceRow {
	background-color: #dddddd;
}

#generalLedgerList {
	border-collapse: collapse;
	min-width: 400px;
}

#generalLedgerList td {
	margin: 3px;
}
</style>

<div class="clearCenter">
	Date Range:
	<select id="dateRangeType">
		<option value="fy">Current Fiscal Year</option>
		<option value="lastfy">Previous Fiscal Year</option>
		<option value="month">Current Month</option>
		<option value="lastmonth">Previous Month</option>
	</select>
</div>

<div id="generalLedgerWrapper" class="clearCenter"
	style="max-width: 75%">
	<fieldset>
		<legend>General Ledger</legend>

		<table class="formatTable" id="generalLedgerList" border="1"
			summary="General Ledger">
			<thead>
				<tr id="totalRow">
					<td class="noborder">TOTAL</td>
					<td class="noborder"></td>
					<td class="noborder"></td>
					<td class="noborder"></td>
					<td class="noborder"></td>
				</tr>
				<tr>
					<th>General Post Fund</th>
					<th>Current Balance</th>
					<th>Total Donations</th>
					<th>Total Expenditures</th>
					<th>Total Adjustments</th>
					<%--
					<c:if test="${not FORM_READ_ONLY}">
						<th>Action</th>
					</c:if>
					--%>
				</tr>
			</thead>
			<tbody>
			</tbody>
		</table>
	</fieldset>
</div>
