var donationSearchResults = new Object()

function popupDonationSearch(uid, options) {
	var dialogEl = $("#donationSearchDialog" + uid)
	
	options = $.extend({
		beginDate : '',
		endDate : '',
		donorName : '',
		donorType : '',
		donationId : ''
	}, options)

	$("#donationSearchBeginDate" + uid).val(options.beginDate)
	$("#donationSearchEndDate" + uid).val(options.endDate)
	$("#donationSearchDonorName" + uid).val(options.donorName)
	$("#donationSearchDonorType" + uid).val(options.donorType)  
	$("#donationId" + uid).val(options.donationId)
	
	$("#donationSearchNoResults" + uid).hide()
	$("#donationSearchResultsTable" + uid).hide()
	$('#donationSearchBeginDate' + uid).focus()
	$("#donationSearchDialog" + uid).dialog('open')
}

function donationSearchPopupItemSelected(uid, donationId) {
	var donationObj = donationSearchResults[uid]['' + donationId].donation
	var fullObj = donationSearchResults[uid]['' + donationId]
	var theDialog = $("#donationSearchDialog" + uid)
	theDialog.dialog('close')
	theDialog.data('callbackMethod')(donationObj, fullObj)
}

function initDonationSearchPopup(options) {
	var uid = options.uid
	var maxResults = options.maxResults
	var callbackMethod = options.callbackMethod
	
	var parms = {
		"columnDefs" : [
				{
					"targets" : 0,
					"data" : function(row, type, val, meta) {
						var donationNameEscaped = '';
						donationNameEscaped = escapeHTML(row.donation.displayName)
						
						if (type === 'display') {
							return '<a class="appLink" href="javascript:donationSearchPopupItemSelected(\''
									+ uid + '\', ' + row.donation.id 
									+ ')">'
									+ donationNameEscaped
						} else {
							return donationNameEscaped
						}
					}
				},
				{
					"targets" : 1,
					"data" : function(row, type, val, meta) {
						return row.donation.volunteer? 'Yes' : 'No'
					}
				},
				{
					"targets" : 2,
					"data" : function(row, type, val, meta) {
						var theText = escapeHTML((row.orgFacility) ? row.orgFacility.displayName : '')
						if (type === 'filter') {
							return abbreviate(theText, 25)
						}
						return theText
					}
				},
				{
					"targets" : 3,
					"data" : function(row, type, val, meta) {
						return escapeHTML(row.orgContactName)
					}
				},
				{
					"targets" : 4,
					"data" : function(row, type, val, meta) {
						var	contactInfoHtml = ''
						contactInfoHtml = getDonationDashedBoxEl(row.donation)
	
						return contactInfoHtml
					}
				}, 
				{
					"targets" : 5,
					"data" : function(row, type, val, meta) {
						var theText = escapeHTML(row.facility ? row.facility.displayName : '')
						if (type === 'filter') {
							return abbreviate(theText, 25)
						}
						return theText
					}
				},
				{
					"targets" : 6,
					"data" : function(row, type, val, meta) {
						if (type === 'display' || type === 'filter') {
							return escapeHTML(row.donationDate)
						} else {
							// sort
							return getAsYYYYMMDD(row.donationDate)
						}
					}
				},
				{
					"targets" : 7,
					"data" : function(row, type, val, meta) {
						return escapeHTML(row.donationType? row.donationType.donationType : '')
					}
				},
				{
					"targets" : 8,
					"data" : function(row, type, val, meta) {
						return escapeHTML(row.donationValue ? '$'+ formatAndAddThousandSeparators(row.donationValue): '');
						
					}
				}
			],
		"dom" : '<"top"fi>rt<"bottom"pl><"clear">',
		"pagingType" : "full_numbers",
		"pageLength" : 10,
		"lengthMenu" : [ [ 10, -1 ], [ 10, "All" ] ],
		"stateSave" : false
	}

	var theDataTable = $('#donationSearchResultsList' + uid).DataTable(parms)

	var dialogEl = $("#donationSearchDialog" + uid)
	
	var buttonConfig = {}
	buttonConfig['Cancel'] = function() { $(this).dialog('close') }
	
	dialogEl.dialog({
		autoOpen : false,
		modal : false,
		width : 1200,
		height : 750,
		closeOnEscape : true,
		draggable : true,
		resizable : true,
		buttons : buttonConfig
	})
	dialogEl.data('maxResults', maxResults)
	dialogEl.data('callbackMethod', callbackMethod)
	
	$("input[name=donationSearchType" + uid + "]").click(function(evt) {
		donationSearchToggleFields(uid)
	})

	$.each(["#donationSearchFirstName" + uid, "#donationSearchLastName" + uid, "#donationSearchOrgName" + uid], function(index,
			value) {
		$(value).keypress(function(event) {
			if (event.which == 13) {
				submitDonationSearchForm(uid)
			}
		})
	})
	
	$(".donationSearchLink" + uid).click(function(evt) {
		submitDonationSearchForm(uid)
	})
	
	donationSearchToggleFields(uid)
	dialogEl.show()
}

function donationSearchToggleFields(uid) {
	var isIndividual = $("#donationSearchTypeIndividual" + uid).is(":checked") 
	$('.donationSearchToggleFields' + uid).toggle(isIndividual)
	$('.orgSearchToggleFields' + uid).toggle(!isIndividual)
	
	$("#donationSearchNoResults" + uid).hide()
	
	if (isIndividual) {
		$('#donationSearchLastName' + uid).focus()
	} else {
		$('#donationSearchOrgName' + uid).focus()
	}
}

function submitDonationSearchForm(uid) { 
	if (allValsEmpty(["donationSearchBeginDate" + uid,
	                  "donationSearchEndDate" + uid,
	                  "donationSearchDonorName" + uid,
	                  "donationSearchDonorType" + uid,
	                  "donationSearchDonationId" + uid])) {
		displayAttentionDialog('Please enter at least one piece of search criteria.')
		return
	}
	
	var dialogEl = $("#donationSearchDialog" + uid)
				
	$.ajax({
		url : ajaxHomePath + "/donation/search",
		type : "POST",
		dataType : 'json',
		data : {
			beginDate : $("#donationSearchBeginDate" + uid).val(),
			endDate : $("#donationSearchEndDate" + uid).val(),
			donorName : $("#donationSearchDonorName" + uid).val(),
			donorTypeId : $("#donationSearchDonorType" + uid).val(),
			donationId : $("#donationSearchDonationId" + uid).val(),
		},
		error : commonAjaxErrorHandler,
		success : function(results) {
			processDonationSearchResults(uid, results)
		}
	})
}

function processDonationSearchResults(uid, results) {
	var dialogEl = $("#donationSearchDialog" + uid)
	
	$("#donationSearchNoResults" + uid).hide()
	$("#donationSearchResultsTable" + uid).hide()

	var resultMap = new Object()

	var table = $('#donationSearchResultsList' + uid).DataTable()
	table.clear()

	for (var i = 0; i < results.length; i++) {
		resultMap['' + results[i].donation.id] = results[i]
		table.row.add(results[i])
	}

	donationSearchResults[uid] = resultMap

	$("#donationSearchMaxResults" + uid).toggle(results.length >= dialogEl.data('maxResults'))
	
	if (results.length > 0) {
		
		var isOrganization = $("#donationSearchTypeOrganization" + uid).is(":checked") 
		toggleResultsColumns(table, isOrganization)
		
		table.search('').columns().search('')
		rebuildTableFilters('donationSearchResultsList' + uid)
		
		$("#donationSearchResultsTable" + uid).show()

	} else {
		$("#donationSearchNoResults" + uid).show()
	}
	table.draw()

	$('#donationSearchLastName' + uid).focus()
}

function toggleResultsColumns(table, isOrg) {
    table.column(1).visible(!isOrg)
    table.column(2).visible(isOrg)
    table.column(3).visible(isOrg)
}