package gov.va.vss.persistence;

import java.time.LocalDate;

import org.junit.Test;

import gov.va.vss.AbstractTransactionalWebDAOTest;
import gov.va.vss.model.donation.DonGenPostFund;
import gov.va.vss.persistence.dao.CustomizableAppDAO;

public class TestDonGenPostFundDAO extends AbstractTransactionalWebDAOTest<DonGenPostFund> {

	@Override
	protected CustomizableAppDAO<DonGenPostFund> getDAO() {
		return donGenPostFundDAO;
	}

	@Override
	protected DonGenPostFund getInstanceToSave() {
		DonGenPostFund dl = new DonGenPostFund();
		dl.setFacility(getFacility());
		dl.setGeneralPostFund("9054 - TEST_FUND");
		return dl;
	}

	@Override
	protected boolean testDelete() {
		return true;
	}

	@Test
	public void testGetDonGenPostFundReportByFacility() {
		donGenPostFundDAO.getDonGenPostFundReportByFacility(getFacility().getId(), LocalDate.of(2014, 10, 1),
				LocalDate.of(2015, 9, 30));
	}

}
